X-Git-Url: https://git.madduck.net/code/vcsh.git/blobdiff_plain/ecb36d5d99bdcebd781c5cb17780f51020f896b7..de1c75a12e9f0f586b1973d3866ad4707d263a08:/vcsh?ds=inline

diff --git a/vcsh b/vcsh
index d6ee234..a374f05 100755
--- a/vcsh
+++ b/vcsh
@@ -1,7 +1,7 @@
 #!/bin/sh
 
 # This program is licensed under the GNU GPL version 2 or later.
-# (c) Richard "RichiH" Hartmann <richih@debian.org>, 2011-2013
+# (c) Richard "RichiH" Hartmann <richih@debian.org>, 2011-2014
 # For details, see LICENSE. To submit patches, you have to agree to
 # license your code under the GNU GPL version 2 or later.
 
@@ -15,16 +15,12 @@
 # This should always be the first line of code to facilitate debugging
 [ -n "$VCSH_DEBUG" ] && set -vx
 
-basename() {
-	# Implemented in shell to avoid spawning another process
-	local file
-	file="${1##*/}"
-	[ -z "$2" ] || file="${file%$2}"
-	echo "$file"
-}
 
+# If '.git-HEAD' is appended to the version, you are seeing an unreleased
+# version of vcsh; the master branch is supposed to be clean at all times
+# so you can most likely just use it nonetheless
+VERSION='1.20141009'
 SELF=$(basename $0)
-VERSION='1.20130909'
 
 fatal() {
 	echo "$SELF: fatal: $1" >&2
@@ -35,16 +31,16 @@ fatal() {
 # options that will modify our behaviour.
 # Commands are handled at the end of this script.
 while getopts "c:dv" flag; do
-	if [ "$1" = '-d' ] || [ "$1" = '--debug' ]; then
+	if [ x"$1" = x'-d' ] || [ x"$1" = x'--debug' ]; then
 		set -vx
 		VCSH_DEBUG=1
 		echo "debug mode on"
 		echo "$SELF $VERSION"
-	elif [ "$1" = '-v' ];then
+	elif [ x"$1" = x'-v' ]; then
 		VCSH_VERBOSE=1
 		echo "verbose mode on"
 		echo "$SELF $VERSION"
-	elif [ "$1" = '-c' ];then
+	elif [ x"$1" = x'-c' ]; then
 		VCSH_OPTION_CONFIG=$OPTARG
 	fi
 	shift 1
@@ -52,7 +48,7 @@ done
 
 source_all() {
 	# Source file even if it's in $PWD and does not have any slashes in it
-	case "$1" in
+	case $1 in
 		*/*) . "$1";;
 		*)   . "$PWD/$1";;
 	esac;
@@ -61,7 +57,7 @@ source_all() {
 
 # Read configuration and set defaults if anything's not set
 [ -n "$VCSH_DEBUG" ]                  && set -vx
-[ -z "$XDG_CONFIG_HOME" ]             && XDG_CONFIG_HOME="$HOME/.config"
+: ${XDG_CONFIG_HOME:="$HOME/.config"}
 
 # Read configuration files if there are any
 [ -r "/etc/vcsh/config" ]             && . "/etc/vcsh/config"
@@ -77,11 +73,12 @@ fi
 [ -n "$VCSH_DEBUG" ]                  && set -vx
 
 # Read defaults
-[ -z "$VCSH_REPO_D" ]                 && VCSH_REPO_D="$XDG_CONFIG_HOME/vcsh/repo.d"
-[ -z "$VCSH_HOOK_D" ]                 && VCSH_HOOK_D="$XDG_CONFIG_HOME/vcsh/hooks-enabled"
-[ -z "$VCSH_BASE" ]                   && VCSH_BASE="$HOME"
-[ -z "$VCSH_GITIGNORE" ]              && VCSH_GITIGNORE='exact'
-[ -z "$VCSH_WORKTREE" ]               && VCSH_WORKTREE='absolute'
+: ${VCSH_REPO_D:="$XDG_CONFIG_HOME/vcsh/repo.d"}
+: ${VCSH_HOOK_D:="$XDG_CONFIG_HOME/vcsh/hooks-enabled"}
+: ${VCSH_BASE:="$HOME"}
+: ${VCSH_GITIGNORE:=exact}
+: ${VCSH_GITATTRIBUTES:=none}
+: ${VCSH_WORKTREE:=absolute}
 
 if [ ! "x$VCSH_GITIGNORE" = 'xexact' ] && [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && [ ! "x$VCSH_GITIGNORE" = 'xrecursive' ]; then
 	fatal "'\$VCSH_GITIGNORE' must equal 'exact', 'none', or 'recursive'" 1
@@ -156,15 +153,17 @@ clone() {
 		exit
 	fi
 	git fetch
-	for object in $(git ls-tree -r origin/master | awk '{print $4}'); do
+	hook pre-merge
+	git ls-tree -r --name-only origin/master | (while read object; do
 		[ -e "$object" ] &&
 			error "'$object' exists." &&
-			VCSH_CONFLICT=1;
+			VCSH_CONFLICT=1
 	done
-	[ "$VCSH_CONFLICT" = '1' ] &&
+	[ x"$VCSH_CONFLICT" = x'1' ]) &&
 		fatal "will stop after fetching and not try to merge!
-  Once this situation has been resolved, run 'vcsh run $VCSH_REPO_NAME git pull' to finish cloning.\n" 17
+  Once this situation has been resolved, run 'vcsh $VCSH_REPO_NAME pull' to finish cloning." 17
 	git merge origin/master
+	hook post-merge
 	hook post-clone
 	retire
 	hook post-clone-retired
@@ -174,9 +173,10 @@ commit() {
 	hook pre-commit
 	for VCSH_REPO_NAME in $(list); do
 		echo "$VCSH_REPO_NAME: "
-		export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+		GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
 		use
 		git commit --untracked-files=no --quiet
+		VCSH_COMMAND_RETURN_CODE=$?
 		echo
 	done
 	hook post-commit
@@ -213,7 +213,7 @@ git_dir_exists() {
 }
 
 hook() {
-	for hook in $VCSH_HOOK_D/$1* $VCSH_HOOK_D/$VCSH_REPO_NAME.$1*; do
+	for hook in "$VCSH_HOOK_D/$1"* "$VCSH_HOOK_D/$VCSH_REPO_NAME.$1"*; do
 		[ -x "$hook" ] || continue
 		verbose "executing '$hook'"
 		"$hook"
@@ -225,40 +225,43 @@ init() {
 	[ ! -e "$GIT_DIR" ] || fatal "'$GIT_DIR' exists" 10
 	mkdir -p "$VCSH_BASE" || fatal "could not create '$VCSH_BASE'" 50
 	cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
-	git init
+	git init --shared=0600
 	upgrade
 	hook post-init
 }
 
 list() {
 	for repo in "$VCSH_REPO_D"/*.git; do
-		[ -d "$repo" ] && [ -r "$repo" ] && echo $(basename "$repo" .git)
+		[ -d "$repo" ] && [ -r "$repo" ] && echo "$(basename "$repo" .git)"
 	done
 }
 
 get_files() {
-	export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+	GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
 	git ls-files
 }
 
 list_tracked() {
 	for VCSH_REPO_NAME in $(list); do
 		get_files
-	done | sort -u
+	done | sed "s,^,$(printf '%s\n' "$VCSH_BASE/" | \
+	    sed 's/[,\&]/\\&/g')," | sort -u
 }
 
 list_tracked_by() {
 	use
-	git ls-files | sort -u
+	git ls-files | sed "s,^,$(printf '%s\n' "$VCSH_BASE/" | \
+	    sed 's/[,\&]/\\&/g')," | sort -u
 }
 
 pull() {
 	hook pre-pull
 	for VCSH_REPO_NAME in $(list); do
-		echo -n "$VCSH_REPO_NAME: "
-		export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+		printf '%s: ' "$VCSH_REPO_NAME"
+		GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
 		use
 		git pull
+		VCSH_COMMAND_RETURN_CODE=$?
 		echo
 	done
 	hook post-pull
@@ -267,10 +270,11 @@ pull() {
 push() {
 	hook pre-push
 	for VCSH_REPO_NAME in $(list); do
-		echo -n "$VCSH_REPO_NAME: "
-		export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+		printf '%s: ' "$VCSH_REPO_NAME"
+		GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
 		use
 		git push
+		VCSH_COMMAND_RETURN_CODE=$?
 		echo
 	done
 	hook post-push
@@ -280,6 +284,45 @@ retire() {
 	unset VCSH_DIRECTORY
 }
 
+list_untracked() {
+	command -v 'comm' >/dev/null 2>&1 || fatal "Could not find 'comm'"
+
+	temp_file_others=$(mktemp "${TMPDIR:-/tmp}/tmp.XXXXXXXXXX") || fatal 'Could not create temp file'
+	temp_file_untracked=$(mktemp "${TMPDIR:-/tmp}/tmp.XXXXXXXXXX") || fatal 'Could not create temp file'
+	temp_file_untracked_copy=$(mktemp "${TMPDIR:-/tmp}/tmp.XXXXXXXXXX") || fatal 'Could not create temp file'
+
+	# Hack in support for `vcsh list-untracked -r`
+	directory_opt="--directory"
+	shift 1
+	while getopts "r" flag; do
+		if [ x"$1" = x'-r' ]; then
+			unset directory_opt
+		fi
+		shift 1
+	done
+
+	for VCSH_REPO_NAME in $(list); do
+		export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+		git ls-files --others "$directory_opt" | (
+			while read line; do
+				echo "$line"
+				directory_component="$(echo "$line" | cut -d'/' -f1)"
+				[ -d "$directory_component" ] && printf '%s/\n' "$directory_component"
+			done
+			) | sort -u > $temp_file_others
+		if [ -z "$ran_once" ]; then
+			ran_once=1
+			cp $temp_file_others $temp_file_untracked || fatal 'Could not copy temp file'
+		fi
+		cp $temp_file_untracked $temp_file_untracked_copy || fatal 'Could not copy temp file'
+		comm -12 --nocheck-order $temp_file_others $temp_file_untracked_copy > $temp_file_untracked
+	done
+	cat $temp_file_untracked
+
+	unset directory_opt directory_component
+	rm -f $temp_file_others $temp_file_untracked $temp_file_untracked_copy || fatal 'Could not delete temp files'
+}
+
 rename() {
 	git_dir_exists
 	[ -d "$GIT_DIR_NEW" ] && fatal "'$GIT_DIR_NEW' exists" 54
@@ -287,8 +330,8 @@ rename() {
 
 	# Now that the repository has been renamed, we need to fix up its configuration
 	# Overwrite old name..
-	GIT_DIR="$GIT_DIR_NEW"
-	$VCSH_REPO_NAME="$VCSH_REPO_NAME_NEW"
+	GIT_DIR=$GIT_DIR_NEW
+	VCSH_REPO_NAME=$VCSH_REPO_NAME_NEW
 	# ..and clobber all old configuration
 	upgrade
 }
@@ -297,20 +340,23 @@ run() {
 	hook pre-run
 	use
 	"$@"
+	VCSH_COMMAND_RETURN_CODE=$?
 	hook post-run
 }
 
 status() {
-	if [ ! "x$VCSH_REPO_NAME" = "x" ]; then
-		export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+	if [ -n "$VCSH_REPO_NAME" ]; then
+		GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
 		use
 		git status --short --untracked-files='no'
+		VCSH_COMMAND_RETURN_CODE=$?
 	else
 		for VCSH_REPO_NAME in $(list); do
 			echo "$VCSH_REPO_NAME:"
-			export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+			GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
 			use
 			git status --short --untracked-files='no'
+			VCSH_COMMAND_RETURN_CODE=$?
 			echo
 		done
 	fi
@@ -325,26 +371,28 @@ upgrade() {
 	# core.worktree may be absolute or relative to $GIT_DIR, depending on
 	# user preference
 	if [ ! "x$VCSH_WORKTREE" = 'xabsolute' ]; then
-		git config core.worktree $(cd $GIT_DIR && GIT_WORK_TREE="$VCSH_BASE" git rev-parse --show-cdup)
+		git config core.worktree "$(cd "$GIT_DIR" && GIT_WORK_TREE=$VCSH_BASE git rev-parse --show-cdup)"
 	elif [ ! "x$VCSH_WORKTREE" = 'xrelative' ]; then
 		git config core.worktree "$VCSH_BASE"
 	fi
 	[ ! "x$VCSH_GITIGNORE" = 'xnone' ] && git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
-	git config vcsh.vcsh         'true'
+	[ ! "x$VCSH_GITATTRIBUTES" = 'xnone' ] && git config core.attributesfile ".gitattributes.d/$VCSH_REPO_NAME"
+	git config vcsh.vcsh 'true'
 	use
 	[ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ] && git add -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME"
+	[ -e "$VCSH_BASE/.gitattributes.d/$VCSH_REPO_NAME" ] && git add -f "$VCSH_BASE/.gitattributes.d/$VCSH_REPO_NAME"
 	hook post-upgrade
 }
 
 use() {
 	git_dir_exists
-	export VCSH_DIRECTORY="$VCSH_REPO_NAME"
+	VCSH_DIRECTORY=$VCSH_REPO_NAME; export VCSH_DIRECTORY
 }
 
 which() {
 	for VCSH_REPO_NAME in $(list); do
 		for VCSH_FILE in $(get_files); do
-			echo $VCSH_FILE | grep -q "$VCSH_COMMAND_PARAMETER" && echo "$VCSH_REPO_NAME: $VCSH_FILE"
+			echo "$VCSH_FILE" | grep -q "$VCSH_COMMAND_PARAMETER" && echo "$VCSH_REPO_NAME: $VCSH_FILE"
 		done
 	done | sort -u
 }
@@ -358,17 +406,20 @@ write_gitignore() {
 
 	use
 	cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
+	OLDIFS=$IFS
+	IFS=$(printf '\n\t')
 	gitignores=$(for file in $(git ls-files); do
 		while true; do
-			echo $file; new="${file%/*}"
-			[ "$file" = "$new" ] && break
-			file="$new"
+			echo "$file"; new=${file%/*}
+			[ x"$file" = x"$new" ] && break
+			file=$new
 		done;
 	done | sort -u)
 
 	# Contrary to GNU mktemp, mktemp on BSD/OSX requires a template for temp files
-	# Use the template GNU mktemo defaults to
-	tempfile=$(mktemp tmp.XXXXXXXXXX) || fatal "could not create tempfile" 51
+	# Using a template makes GNU mktemp default to $PWD and not #TMPDIR for tempfile location
+	# To make every OS happy, set full path explicitly
+	tempfile=$(mktemp "${TMPDIR:-/tmp}/tmp.XXXXXXXXXX") || fatal "could not create tempfile: '${tempfile}'" 51
 
 	echo '*' > "$tempfile" || fatal "could not write to '$tempfile'" 57
 	for gitignore in $gitignores; do
@@ -377,6 +428,7 @@ write_gitignore() {
 			{ echo "$gitignore/*" | sed 's@^@!/@' >> "$tempfile" || fatal "could not write to '$tempfile'" 57; }
 		fi
 	done
+	IFS=$OLDIFS
 	if diff -N "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" > /dev/null; then
 		rm -f "$tempfile" || error "could not delete '$tempfile'"
 		exit
@@ -390,59 +442,84 @@ write_gitignore() {
 		fatal "could not move '$tempfile' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME'" 53
 }
 
-if [ "$1" = 'clone' ]; then
-	[ -z "$2" ] && fatal "$1: please specify a remote" 1
-	export VCSH_COMMAND="$1"
+debug $(git version)
+
+if [ ! "x$VCSH_GITIGNORE" = 'xexact' ] && [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && [ ! "x$VCSH_GITIGNORE" = 'xrecursive' ]; then
+	fatal "'\$VCSH_GITIGNORE' must equal 'exact', 'none', or 'recursive'" 1
+fi
+
+VCSH_COMMAND=$1; export VCSH_COMMAND
+
+case $VCSH_COMMAND in
+	clon|clo|cl) VCSH_COMMAND=clone;;
+	commi|comm|com|co) VCSH_COMMAND=commit;;
+	delet|dele|del|de) VCSH_COMMAND=delete;;
+	ente|ent|en) VCSH_COMMAND=enter;;
+	hel|he) VCSH_COMMAND=help;;
+	ini|in) VCSH_COMMAND=init;;
+	pul) VCSH_COMMAND=pull;;
+	pus) VCSH_COMMAND=push;;
+	renam|rena|ren|re) VCSH_COMMAND=rename;;
+	ru) VCSH_COMMAND=run;;
+	statu|stat|sta|st) VCSH_COMMAND=status;;
+	upgrad|upgra|upgr|up) VCSH_COMMAND=upgrade;;
+	versio|versi|vers|ver|ve) VCSH_COMMAND=version;;
+	which|whi|wh) VCSH_COMMAND=which;;
+	write|writ|wri|wr) VCSH_COMMAND=write-gitignore;;
+esac    
+
+if [ x"$VCSH_COMMAND" = x'clone' ]; then
+	[ -z "$2" ] && fatal "$VCSH_COMMAND: please specify a remote" 1
 	GIT_REMOTE="$2"
-	[ -n "$3" ] && VCSH_REPO_NAME="$3" || VCSH_REPO_NAME=$(basename "$GIT_REMOTE" .git)
+	[ -n "$3" ] && VCSH_REPO_NAME=$3 || VCSH_REPO_NAME=$(basename "${GIT_REMOTE#*:}" .git)
+	[ -z "$VCSH_REPO_NAME" ] && fatal "$VCSH_COMMAND: could not determine repository name" 1
 	export VCSH_REPO_NAME
-	export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
-elif [ "$1" = 'version' ]; then
+	GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
+elif [ "$VCSH_COMMAND" = 'version' ]; then
 	echo "$SELF $VERSION"
+	git version
 	exit
-elif [ "$1" = 'which' ]; then
-	[ -z "$2" ] && fatal "$1: please specify a filename" 1
-	[ -n "$3" ] && fatal "$1: too many parameters" 1
-	export VCSH_COMMAND="$1"
-	export VCSH_COMMAND_PARAMETER="$2"
-elif [ "$1" = 'delete' ]           ||
-     [ "$1" = 'enter' ]            ||
-     [ "$1" = 'init' ]             ||
-     [ "$1" = 'list-tracked-by' ]  ||
-     [ "$1" = 'rename' ]           ||
-     [ "$1" = 'run' ]              ||
-     [ "$1" = 'upgrade' ]          ||
-     [ "$1" = 'write-gitignore' ]; then
-	[ -z $2 ]                      && fatal "$1: please specify repository to work on" 1
-	[ "$1" = 'rename' -a -z "$3" ] && fatal "$1: please specify a target name" 1
-	[ "$1" = 'run'    -a -z "$3" ] && fatal "$1: please specify a command" 1
-	export VCSH_COMMAND="$1"
-	export VCSH_REPO_NAME="$2"
-	export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
-	[ "$VCSH_COMMAND" = 'rename' ] && { export VCSH_REPO_NAME_NEW="$3";
-	                                    export GIT_DIR_NEW="$VCSH_REPO_D/$VCSH_REPO_NAME_NEW.git"; }
-	[ "$VCSH_COMMAND" = 'run' ]    && shift 2
-elif [ "$1" = 'commit' ] ||
-     [ "$1" = 'list' ] ||
-     [ "$1" = 'list-tracked' ] ||
-     [ "$1" = 'pull' ] ||
-     [ "$1" = 'push' ]; then
-	export VCSH_COMMAND="$1"
-elif [ "$1" = 'status' ]; then
-	export VCSH_COMMAND="$1"
-	export VCSH_REPO_NAME="$2"
+elif [ x"$VCSH_COMMAND" = x'which' ]; then
+	[ -z "$2" ] && fatal "$VCSH_COMMAND: please specify a filename" 1
+	[ -n "$3" ] && fatal "$VCSH_COMMAND: too many parameters" 1
+	VCSH_COMMAND_PARAMETER=$2; export VCSH_COMMAND_PARAMETER
+elif [ x"$VCSH_COMMAND" = x'delete' ]           ||
+     [ x"$VCSH_COMMAND" = x'enter' ]            ||
+     [ x"$VCSH_COMMAND" = x'init' ]             ||
+     [ x"$VCSH_COMMAND" = x'list-tracked-by' ]  ||
+     [ x"$VCSH_COMMAND" = x'rename' ]           ||
+     [ x"$VCSH_COMMAND" = x'run' ]              ||
+     [ x"$VCSH_COMMAND" = x'upgrade' ]          ||
+     [ x"$VCSH_COMMAND" = x'write-gitignore' ]; then
+	[ -z "$2" ]                                     && fatal "$VCSH_COMMAND: please specify repository to work on" 1
+	[ x"$VCSH_COMMAND" = x'rename' ] && [ -z "$3" ] && fatal "$VCSH_COMMAND: please specify a target name" 1
+	[ x"$VCSH_COMMAND" = x'run'    ] && [ -z "$3" ] && fatal "$VCSH_COMMAND: please specify a command" 1
+	VCSH_REPO_NAME=$2; export VCSH_REPO_NAME
+	GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
+	[ x"$VCSH_COMMAND" = x'rename' ] && { VCSH_REPO_NAME_NEW=$3; export VCSH_REPO_NAME_NEW;
+	                                      GIT_DIR_NEW=$VCSH_REPO_D/$VCSH_REPO_NAME_NEW.git; export GIT_DIR_NEW; }
+	[ x"$VCSH_COMMAND" = x'run' ]    && shift 2
+elif [ x"$VCSH_COMMAND" = x'commit' ] ||
+     [ x"$VCSH_COMMAND" = x'list'   ] ||
+     [ x"$VCSH_COMMAND" = x'list-tracked' ] ||
+     [ x"$VCSH_COMMAND" = x'list-untracked' ] ||
+     [ x"$VCSH_COMMAND" = x'pull'   ] ||
+     [ x"$VCSH_COMMAND" = x'push'   ]; then
+	:
+elif [ x"$VCSH_COMMAND" = x'status' ]; then
+	VCSH_REPO_NAME=$2; export VCSH_REPO_NAME
 elif [ -n "$2" ]; then
-	export VCSH_COMMAND='run'
-	export VCSH_REPO_NAME="$1"
-	export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
-	[ -d $GIT_DIR ] || { help; exit 1; }
+	VCSH_COMMAND='run'; export VCSH_COMMAND
+	VCSH_REPO_NAME=$1; export VCSH_REPO_NAME
+	GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
+	[ -d "$GIT_DIR" ] || { help; exit 1; }
 	shift 1
 	set -- "git" "$@"
-elif [ -n "$1" ]; then
-	export VCSH_COMMAND='enter'
-	export VCSH_REPO_NAME="$1"
-	export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
-	[ -d $GIT_DIR ] || { help; exit 1; }
+elif [ -n "$VCSH_COMMAND" ]; then
+	VCSH_COMMAND='enter'; export VCSH_COMMAND
+	VCSH_REPO_NAME=$1; export VCSH_REPO_NAME
+	GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
+	[ -d "$GIT_DIR" ] || { help; exit 1; }
 else
 	# $1 is empty, or 'help'
 	help && exit
@@ -450,9 +527,9 @@ fi
 
 # Did we receive a directory instead of a name?
 # Mangle the input to fit normal operation.
-if echo $VCSH_REPO_NAME | grep -q '/'; then
-	export GIT_DIR=$VCSH_REPO_NAME
-	export VCSH_REPO_NAME=$(basename "$VCSH_REPO_NAME" .git)
+if echo "$VCSH_REPO_NAME" | grep -q '/'; then
+	GIT_DIR=$VCSH_REPO_NAME; export GIT_DIR
+	VCSH_REPO_NAME=$(basename "$VCSH_REPO_NAME" .git); export VCSH_REPO_NAME
 fi
 
 check_dir() {
@@ -469,10 +546,12 @@ check_dir() {
 
 check_dir "$VCSH_REPO_D"
 [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && check_dir "$VCSH_BASE/.gitignore.d"
+[ ! "x$VCSH_GITATTRIBUTES" = 'xnone' ] && check_dir "$VCSH_BASE/.gitattributes.d"
 
 verbose "$VCSH_COMMAND begin"
-export VCSH_COMMAND=$(echo $VCSH_COMMAND | sed 's/-/_/g')
+VCSH_COMMAND=$(echo "$VCSH_COMMAND" | sed 's/-/_/g'); export VCSH_COMMAND
 hook pre-command
 $VCSH_COMMAND "$@"
 hook post-command
 verbose "$VCSH_COMMAND end, exiting"
+exit $VCSH_COMMAND_RETURN_CODE